<?php
namespace CE;

class Base{
	public static function aggregateElement($dataType, $category, $article, $elemValues){
		//Verificar el tipo de elemento a agregar

		switch ($dataType) {
			case 'text':
				
				if($elemValues['type'] == 'default'){
					//Por default, la imagen edita el src
					return \CE\Base::handleTextAggretation($dataType, $category, $article, $elemValues);
				}
				
				break;

			case 'image':
				
				if($elemValues['type'] == 'default'){
					//Por default, la imagen edita el src
					return \CE\Base::handleImageAggretation($dataType, $category, $article, $elemValues);
				}elseif ($elemValues['type'] == 'alt'){
					//Editar el alt de la imagen
					return \CE\Base::handleImageAltChange($dataType, $category, $article, $elemValues);
				}
				
				break;

			case 'anchor':
				
				if($elemValues['type'] == 'default'){
					//Por default, la imagen edita el src
					return \CE\Base::handleAnchorAggretation($dataType, $category, $article, $elemValues);
				}
				
				break;

			default:
				# code...
				break;
		}

	}

	public static function removeElement($dataType, $category, $article, $elemValues){
		//Verificar el tipo de elemento a eliminar
		switch ($dataType) {
			case 'article':
				
				if($elemValues['type'] == 'default'){
					//Por default, solo se cambia el estado del articulo 
					return \CE\Base::handleArticleRemoval($dataType, $category, $article);
				}
				
				break;

			default:
				# code...
				break;
		}
	}

	public static function handleImageAggretation($dataType, $category, $article, $elemValues){
		if($category=='none' && $article=='none'){
			
			//Se agrega la imagen a una pagina
			if(\CE\Page::exists($elemValues['pageId'])){
				$pageId = \CE\Page::getId($elemValues['pageId']);

				if(\CE\Image::exists_in_page($pageId, $elemValues['id'])){
					//Actualizar imagen existente
					$imageId = \CE\Image::getID_in_page($pageId, $elemValues['id']);
					return \CE\Image::update($imageId, $elemValues['val']);
				}else{
					//Agregar imagen nueva
					return \CE\Image::insert_to_page($pageId, $elemValues['id'], $elemValues['val']);
				}
			}

		}elseif ($category!='none' && $article!='none'){
			//Se agrega el texto a un articulo
			if(\CE\Category::exists($category)){
				$categoryId = \CE\Category::getId($category);

				$articleId;
				if(\CE\Article::exists_in_category($categoryId, $article)){
					$articleId = \CE\Article::getId($categoryId, $article);
				}else{
					//Crear articulo
					$articleId= \CE\Article::insert_to_category($categoryId, $article);
				}

				//Insertar el texto
				if(\CE\Image::exists_in_article($articleId, $elemValues['id'])){
					//Actualizar texto existente
					$imageId = \CE\Image::getID_in_article($articleId, $elemValues['id']);
					return \CE\Image::update($imageId, $elemValues['val']);
				}else{
					//Agregar texto nuevo
					return \CE\Image::insert_to_article($articleId, $elemValues['id'], $elemValues['val']);
				}
			}
		//No esta definido correctamente en maquetado a que le corresponde el elemento
		}else{
			//No esta bien definido los id!
		}
	}

	public static function handleImageAltChange($dataType, $category, $article, $elemValues){
		if($category=='none' && $article=='none'){
			
			//Se agrega la imagen a una pagina
			if(\CE\Page::exists($elemValues['pageId'])){
				$pageId = \CE\Page::getId($elemValues['pageId']);

				if(\CE\Image::exists_in_page($pageId, $elemValues['id'])){
					//Actualizar imagen existente
					$imageId = \CE\Image::getID_in_page($pageId, $elemValues['id']);
					return \CE\Image::updateAlt($imageId, $elemValues['val']);
				}else{
					\CE\Error::report('Aún no subes una imágen');
				}
			}

		}elseif ($category!='none' && $article!='none'){
			//Se agrega el texto a un articulo
			if(\CE\Category::exists($category)){
				$categoryId = \CE\Category::getId($category);

				$articleId;
				if(\CE\Article::exists_in_category($categoryId, $article)){
					$articleId = \CE\Article::getId($categoryId, $article);
				}else{
					\CE\Error::report('Aún no subes una imágen');
				}

				//Insertar el texto
				if(\CE\Image::exists_in_article($articleId, $elemValues['id'])){
					//Actualizar texto existente
					$imageId = \CE\Image::getID_in_article($articleId, $elemValues['id']);
					return \CE\Image::updateAlt($imageId, $elemValues['val']);
				}else{
					\CE\Error::report('Aún no subes una imágen');
				}
			}
		//No esta definido correctamente en maquetado a que le corresponde el elemento
		}else{
			//No esta bien definido los id!
		}
	}

	public static function handleTextAggretation($dataType, $category, $article, $elemValues){
		//Si el texto corresponde a una pagina normal
		if($category=='none' && $article=='none'){
			
			if(\CE\Page::exists($elemValues['pageId'])){
				$pageId = \CE\Page::getId($elemValues['pageId']);

				if(\CE\Text::exists_in_page($pageId, $elemValues['id'])){
					//Actualizar texto existente
					$textId = \CE\Text::getID_in_page($pageId, $elemValues['id']);
					return \CE\Text::update($textId, $elemValues['val']);
				}else{
					//Agregar texto nuevo
					return \CE\Text::insert_to_page($pageId, $elemValues['id'], $elemValues['val']);
				}
			}
		//El texto corresponde a un articulo
		}elseif ($category!='none' && $article!='none'){
			//Se agrega el texto a un articulo
			if(\CE\Category::exists($category)){
				
				$categoryId = \CE\Category::getId($category);
				$articleId;
				if(\CE\Article::exists_in_category($categoryId, $article)){
					
					$articleId = \CE\Article::getId($categoryId, $article);
				}else{
					//Crear articulo
					$articleId= \CE\Article::insert_to_category($categoryId, $article);
				}

				//Insertar el texto
				
				if(\CE\Text::exists_in_article($articleId, $elemValues['id'])){
					//Actualizar texto existente
					$textId = \CE\Text::getID_in_article($articleId, $elemValues['id']);
					
					return \CE\Text::update($textId, $elemValues['val']);
				}else{
					//Agregar texto nuevo
					return \CE\Text::insert_to_article($articleId, $elemValues['id'], $elemValues['val']);
				}
			}

		//No esta definido correctamente en maquetado a que le corresponde el elemento
		}else{
			//No esta bien definido los id!


		}
	}

	public static function handleAnchorAggretation($dataType, $category, $article, $elemValues){
		if($category=='none' && $article=='none'){
			//Se agrega el enlace a una pagina
			if(\CE\Page::exists($elemValues['pageId'])){
				$pageId = \CE\Page::getId($elemValues['pageId']);

				if(\CE\Anchor::exists_in_page($pageId, $elemValues['id'])){
					//Actualizar enlace existente
					
					$anchorId = \CE\Anchor::getID_in_page($pageId, $elemValues['id']);

					return \CE\Anchor::update($anchorId, $elemValues['val']);
				}else{
					//Agregar enlace nuevo
					return \CE\Anchor::insert_to_page($pageId, $elemValues['id'], $elemValues['val']);
				}
			}

		}elseif ($category!='none' && $article!='none'){
			//Se agrega el texto a un articulo
			if(\CE\Category::exists($category)){
				$categoryId = \CE\Category::getId($category);

				$articleId;
				if(\CE\Article::exists_in_category($categoryId, $article)){
					$articleId = \CE\Article::getId($categoryId, $article);
				}else{
					//Crear articulo
					$articleId= \CE\Article::insert_to_category($categoryId, $article);
				}

				//Insertar el texto
				if(\CE\Anchor::exists_in_article($articleId, $elemValues['id'])){
					//Actualizar texto existente
					$anchorId = \CE\Anchor::getID_in_article($articleId, $elemValues['id']);
					return \CE\Anchor::update($anchorId, $elemValues['val']);
				}else{
					//Agregar texto nuevo
					return \CE\Anchor::insert_to_article($articleId, $elemValues['id'], $elemValues['val']);
				}
			}
		//No esta definido correctamente en maquetado a que le corresponde el elemento
		}else{
			//No esta bien definido los id!
		}
	}

	public static function handleArticleRemoval($dataType, $category, $article){

		if(\CE\Category::exists($category)){
			$categoryId = \CE\Category::getId($category);

			$articleId;
			if(\CE\Article::exists_in_category($categoryId, $article)){
				$articleId = \CE\Article::getId($categoryId, $article);
				return \CE\Article::remove($articleId);
			}else{
				\CE\Error::report('El artículo que intentas eliminar no existe');
			}
		}else{
			\CE\Error::report('El artículo que intentas eliminar no existe');
		}
	}
}
?>