<?php 
namespace CE;

class Category{
	
	//Crea una pagina en base al numero de pagina definido por el maquetador
	public static function createCategory($categoryNumber){

		$stmt = \CE\Connection::$conn->prepare(
			"INSERT INTO categoria (num_categoria, id_cliente) VALUES(?, ?)"
		);

		if($stmt !== false){
			
			$stmt->bind_param('ii', $categoryNumber, \CE\Client::getId());
			$stmt->execute();

			if($stmt !== false){
				$stmt->close();
				return true; //Exito
			}
		}
		return false;
	}

	//Verifica si la pagina existe en base al numero de pagina del maquetador
	public static function exists($categoryNumber){

		$stmt = \CE\Connection::$conn->prepare(
			"SELECT categoria.id FROM categoria WHERE categoria.num_categoria = ? AND id_cliente = ?"
		);

		//file_put_contents("exists.txt", var_export($pageNumber, true));
		//file_put_contents("exists2.txt", var_export(\CE\Client::getId(), true));


		if($stmt !== false){
			
			$stmt->bind_param('ii', $categoryNumber, \CE\Client::getId());
			$stmt->execute();

			$stmt->bind_result($textId);
			if ($stmt->fetch()){
			   return true;
			}
		}
		return false;

	}

	//Obtiene el ID de la pagina a partir del numero definido por el maquetador.
	public static function getID($categoryNumber){

		$stmt = \CE\Connection::$conn->prepare(
			"SELECT categoria.id FROM categoria WHERE categoria.num_categoria = ? AND id_cliente = ?"
		);

		if($stmt !== false){
			
			$stmt->bind_param('ii', $categoryNumber, \CE\Client::getId());
			$stmt->execute();

			$stmt->bind_result($categoryId);
			$stmt->fetch();
			return $categoryId;
		}
		return false;

	}


}
?>