<?php
namespace CE;

class Client{
	
	public static function setConnectionValues($API_key, $domain){
		\CE\Client::$API_key = $API_key;
		\CE\Client::$domain = $domain;
	}

	//Recibe la llave y el dominio enviada desde el cliente y verifica si coincide con la BD
	public static function Connect(){
		try{
			
			$stmt = \CE\Connection::$conn->prepare("
				SELECT cliente.id FROM cliente JOIN dominios_registrados
				ON cliente.id = dominios_registrados.id_cliente	
				WHERE cliente.api_key = ? AND dominios_registrados.nombre = ?
			"
			);
			
			if($stmt === false){
				\CE\Error::report(\CE\Connection::$conn->error);
			}

			$stmt->bind_param('ss', \CE\Client::$API_key, \CE\Client::$domain);
			$stmt->execute();

			$stmt->execute();

			$stmt->bind_result($clientId);
			if ($stmt->fetch()){
			   file_put_contents("clientId.txt", var_export($clientId, true));
			   \CE\Client::$id = $clientId;
			   
			   return true;
			}

		}catch(mysqli_sql_exception $e){
			\CE\Error::report($e->getMessage());
		}
	}

	public static function getId(){
		return \CE\Client::$id;
	}

	private static $API_key;
	private static $domain;
	private static $id;
}
?>