<?php 
namespace CE;

class Page{
	
	//Crea una pagina en base al numero de pagina definido por el maquetador
	public static function createPage($pageNumber){

		$stmt = \CE\Connection::$conn->prepare(
			"INSERT INTO pagina (num_pagina, id_cliente) VALUES(?, ?)"
		);

		if($stmt !== false){
			
			$stmt->bind_param('ii', $pageNumber, \CE\Client::getId());
			$stmt->execute();

			if($stmt !== false){
				$stmt->close();
				return true; //Exito
			}
		}
		return false;
	}

	//Verifica si la pagina existe en base al numero de pagina del maquetador
	public static function exists($pageNumber){

		$stmt = \CE\Connection::$conn->prepare(
			"SELECT pagina.id FROM pagina WHERE pagina.num_pagina = ? AND id_cliente = ?"
		);

		//file_put_contents("exists.txt", var_export($pageNumber, true));
		//file_put_contents("exists2.txt", var_export(\CE\Client::getId(), true));


		if($stmt !== false){
			
			$stmt->bind_param('ii', $pageNumber, \CE\Client::getId());
			$stmt->execute();

			$stmt->bind_result($textId);
			if ($stmt->fetch()){
			   return true;
			}
		}
		return false;

	}

	//Obtiene el ID de la pagina a partir del numero definido por el maquetador.
	public static function getID($pageNumber){

		$stmt = \CE\Connection::$conn->prepare(
			"SELECT pagina.id FROM pagina WHERE pagina.num_pagina = ? AND id_cliente = ?"
		);

		if($stmt !== false){
			
			$stmt->bind_param('ii', $pageNumber, \CE\Client::getId());
			$stmt->execute();

			$stmt->bind_result($pageId);
			$stmt->fetch();
			return $pageId;
		}
		return false;

	}

	public static function getPageElements($pageId){
		try{
			$stmt = "SELECT texto.num_texto, texto.contenido FROM 
						 texto JOIN texto_por_pagina ON texto.id = texto_por_pagina.id_texto AND 
						 texto_por_pagina.id_pagina = ".$pageId.";";
			$stmt.= "SELECT imagen.num_imagen, imagen.src, imagen.alt FROM 
						 imagen JOIN imagen_por_pagina ON imagen.id = imagen_por_pagina.id_imagen AND
						 imagen_por_pagina.id_pagina = ".$pageId.";";
			$stmt.= "SELECT enlace.num_enlace, enlace.href FROM 
						 enlace JOIN enlace_por_pagina ON enlace.id = enlace_por_pagina.id_enlace AND 
						 enlace_por_pagina.id_pagina = ".$pageId.";";


			
			//$stmt->execute();

			if (mysqli_multi_query(\CE\Connection::$conn, $stmt)) {
			    $pageElements = array();
			    do {
			        $currentElemType = array();
					if ($result=mysqli_store_result(\CE\Connection::$conn)) {
					    // Fetch one and one row
					    while ($row=mysqli_fetch_array($result)){
					        $currentElemType[$row[0]] = $row;
					    }
					    // Free result set
					    $fieldInfo = mysqli_fetch_field($result);
						
						$pageElements[$fieldInfo->table]= $currentElemType;
					    mysqli_free_result($result);
					}

				}while(mysqli_next_result(\CE\Connection::$conn));

				file_put_contents("eleents.txt", var_export($pageElements, true));
			    return $pageElements;
			} else {
			    //No hay resultados, crear la tabla.
				
			    \CE\Error::report('Error al crear la consulta.');
			}
		}catch(mysqli_sql_exception $e){
			$stmt->close();
			\CE\Error::report($e->getMessage());
		}
	}

	/*
SELECT categoria.num_categoria, articulo.num_articulo, texto.num_texto, texto.contenido FROM 
categoria JOIN articulos_por_categoria ON categoria.id = articulos_por_categoria.id_categoria AND categoria.num_categoria = 1
JOIN articulo ON articulo.id = articulos_por_categoria.id_articulo
JOIN texto ON texto.id = 

Lista de articulos de la categoria:
SELECT articulo.id, articulo.num_articulo FROM articulo JOIN (articulos_por_categoria JOIN categoria ON articulos_por_categoria.id_categoria = categoria.id) ON articulo.id = articulos_por_categoria.id_articulo
SELECT texto.num_texto, texto.contenido FROM texto JOIN (texto_por_articulo JOIN articulo ON texto_por_articulo.id_articulo = articulo.id) ON texto.id = texto_por_articulo.id_texto

SELECT articulo.id, articulo.num_articulo, texto.num_texto, texto.contenido FROM texto JOIN (
    texto_por_articulo JOIN
    	(articulo JOIN (articulos_por_categoria JOIN categoria ON categoria.id=2 AND articulos_por_categoria.id_categoria = categoria.id) ON articulo.id = articulos_por_categoria.id_articulo)
    ON texto_por_articulo.id_articulo = articulo.id
	)
ON texto.id = texto_por_articulo.id_texto
	*/

	public static function getCategoryElements($categoryId, $categoryNumber, $num_articles){
		try{
			$stmt = "
				SELECT articulo.num_articulo, articulo.esPublico, texto.num_texto, texto.contenido FROM texto JOIN (
				    texto_por_articulo JOIN
				    	(articulo JOIN (SELECT articulos_por_categoria.id_articulo FROM articulos_por_categoria JOIN categoria ON categoria.id=".$categoryId." AND articulos_por_categoria.id_categoria = categoria.id ORDER BY articulos_por_categoria.id_articulo DESC LIMIT ".$num_articles.") AS art_cat ON articulo.id = art_cat.id_articulo AND articulo.estaEliminado = 0)
				    ON texto_por_articulo.id_articulo = articulo.id
					)
				ON texto.id = texto_por_articulo.id_texto;
			";
			$stmt.= "
				SELECT articulo.num_articulo, articulo.esPublico, imagen.num_imagen, imagen.src, imagen.alt FROM imagen JOIN (
				    imagen_por_articulo JOIN
				    	(articulo JOIN (SELECT articulos_por_categoria.id_articulo FROM articulos_por_categoria JOIN categoria ON categoria.id=".$categoryId." AND articulos_por_categoria.id_categoria = categoria.id ORDER BY articulos_por_categoria.id_articulo DESC LIMIT ".$num_articles.") AS art_cat ON articulo.id = art_cat.id_articulo AND articulo.estaEliminado = 0)
				    ON imagen_por_articulo.id_articulo = articulo.id
					)
				ON imagen.id = imagen_por_articulo.id_imagen;
			";
			$stmt.= "
			SELECT articulo.num_articulo, articulo.esPublico,  enlace.num_enlace, enlace.href FROM enlace JOIN (
			    enlace_por_articulo JOIN
			    	(articulo JOIN (SELECT articulos_por_categoria.id_articulo FROM articulos_por_categoria JOIN categoria ON categoria.id=".$categoryId." AND articulos_por_categoria.id_categoria = categoria.id ORDER BY articulos_por_categoria.id_articulo DESC LIMIT ".$num_articles.") AS art_cat ON articulo.id = art_cat.id_articulo AND articulo.estaEliminado = 0)
			    ON enlace_por_articulo.id_articulo = articulo.id
				)
			ON enlace.id = enlace_por_articulo.id_enlace;
			";

			//$stmt->execute();

			if (mysqli_multi_query(\CE\Connection::$conn, $stmt)) {
			    $category = array(); //?
			    $elementTypes = array("texto", "imagen", "enlace");
			    do {
			        $currentType = array_shift($elementTypes);
			        if ($result=mysqli_store_result(\CE\Connection::$conn)) {
					    // Fetch one and one row
					    while ($row=mysqli_fetch_array($result)){
					        $category[$row[0]][$currentType][$row[2]] = array_slice($row, 3);
					        
					        $category[$row[0]]['publico'] = $row[1];
					    }

						mysqli_free_result($result);
					}

				}while(mysqli_next_result(\CE\Connection::$conn));

				
			    return $category;
			} else {
			    //No hay resultados, crear la tabla.
				
			    \CE\Error::report('Error al crear la consulta.');
			}
		}catch(mysqli_sql_exception $e){
			$stmt->close();
			\CE\Error::report($e->getMessage());
		}
	}

	public static function getArticleElements($categoryId, $articleNumber){
		try{
			$stmt = "
				SELECT articulo.num_articulo, texto.num_texto, texto.contenido FROM texto JOIN (
				    texto_por_articulo JOIN
				    	(articulo JOIN (SELECT articulos_por_categoria.id_articulo FROM articulos_por_categoria JOIN categoria ON categoria.id=".$categoryId." AND articulos_por_categoria.id_categoria = categoria.id) AS art_cat ON articulo.id = art_cat.id_articulo)
				    ON texto_por_articulo.id_articulo = articulo.id
					)
				ON texto.id = texto_por_articulo.id_texto WHERE articulo.num_articulo = ".$articleNumber.";
			";
			$stmt.= "
				SELECT articulo.num_articulo, imagen.num_imagen, imagen.src, imagen.alt FROM imagen JOIN (
				    imagen_por_articulo JOIN
				    	(articulo JOIN (SELECT articulos_por_categoria.id_articulo FROM articulos_por_categoria JOIN categoria ON categoria.id=".$categoryId." AND articulos_por_categoria.id_categoria = categoria.id) AS art_cat ON articulo.id = art_cat.id_articulo)
				    ON imagen_por_articulo.id_articulo = articulo.id
					)
				ON imagen.id = imagen_por_articulo.id_imagen WHERE articulo.num_articulo = ".$articleNumber.";
			";
			$stmt.= "
			SELECT articulo.num_articulo, enlace.num_enlace, enlace.href FROM enlace JOIN (
			    enlace_por_articulo JOIN
			    	(articulo JOIN (SELECT articulos_por_categoria.id_articulo FROM articulos_por_categoria JOIN categoria ON categoria.id=".$categoryId." AND articulos_por_categoria.id_categoria = categoria.id) AS art_cat ON articulo.id = art_cat.id_articulo)
			    ON enlace_por_articulo.id_articulo = articulo.id
				)
			ON enlace.id = enlace_por_articulo.id_enlace WHERE articulo.num_articulo = ".$articleNumber.";
			";

			//$stmt->execute();

			if (mysqli_multi_query(\CE\Connection::$conn, $stmt)) {
			    $category = array(); //?
			    $elementTypes = array("texto", "imagen", "enlace");
			    do {
			        $currentType = array_shift($elementTypes);
			        if ($result=mysqli_store_result(\CE\Connection::$conn)) {
					    // Fetch one and one row
					    while ($row=mysqli_fetch_array($result)){
					        $category[$row[0]][$currentType][$row[1]] = array_slice($row, 2);
					    }

						mysqli_free_result($result);
					}

				}while(mysqli_next_result(\CE\Connection::$conn));

				
			    return $category;
			} else {
			    //No hay resultados, crear la tabla.
				
			    \CE\Error::report('Error al crear la consulta.');
			}
		}catch(mysqli_sql_exception $e){
			$stmt->close();
			\CE\Error::report($e->getMessage());
		}
	}

}
?>