<?php 
namespace CE;

class SinglePage{
	
	public static function createPage($pageId){

		try{
			$stmt = \CE\Connection::$conn->prepare(
				"INSERT INTO tipo_pagina (id, id_cliente, tipo) VALUES(?, ?, ?)"
			);
			
			if($stmt === false){
				\CE\Error::report(\CE\Connection::$conn->error);
			}
			$pageType = 'singlepage';
			$stmt->bind_param(
				'iis',
				$pageId,
				\CE\Client::getId(),
				$pageType
			);
			$stmt->execute();
			$stmt->close();
			\CE\Connection::$conn->close();

			return true; //Exito
		}catch(mysqli_sql_exception $e){
			$stmt->close();
			\CE\Error::report($e->getMessage());
		}
	}

	public static function getPageElements($pageId){
		try{
			$stmt = "SELECT text.* FROM text JOIN tipo_pagina ON (text.id_pagina = tipo_pagina.id AND tipo_pagina.tipo ='singlepage') WHERE id_pagina = ".$pageId." AND text.id_cliente = ".\CE\Client::getId().";";
			$stmt.= "SELECT image.* FROM image JOIN tipo_pagina ON (image.id_pagina = tipo_pagina.id AND tipo_pagina.tipo ='singlepage') WHERE id_pagina = ".$pageId." AND image.id_cliente = ".\CE\Client::getId().";";
			$stmt.= "SELECT anchor.* FROM anchor JOIN tipo_pagina ON (anchor.id_pagina = tipo_pagina.id AND tipo_pagina.tipo ='singlepage') WHERE id_pagina = ".$pageId." AND anchor.id_cliente = ".\CE\Client::getId().";";

			file_put_contents("sql_maru.txt", var_export($stmt, true));
			//$stmt->execute();

			if (mysqli_multi_query(\CE\Connection::$conn, $stmt)) {
			    $pageElements = array();
			    do {
			        $currentElemType = array();
					if ($result=mysqli_store_result(\CE\Connection::$conn)) {
					    // Fetch one and one row
					    while ($row=mysqli_fetch_array($result)){
					        $currentElemType[$row['id']] = $row;
					    }
					    // Free result set
					    $fieldInfo = mysqli_fetch_field($result);
						
						$pageElements[$fieldInfo->table]= $currentElemType;
					    mysqli_free_result($result);
					}

				}while(mysqli_next_result(\CE\Connection::$conn));

			    return $pageElements;
			} else {
			    //No hay resultados, crear la tabla.
				
			    \CE\Error::report('Error al crear la consulta.');
			}
		}catch(mysqli_sql_exception $e){
			$stmt->close();
			\CE\Error::report($e->getMessage());
		}
	}

	public static function exists($pageId){
		try{
			$stmt = \CE\Connection::$conn->prepare(
				"SELECT * FROM tipo_pagina WHERE id = ? AND id_cliente = ?"
			);
			
			if($stmt === false){
				\CE\Error::report(\CE\Connection::$conn->error);
			}

			$stmt->bind_param('ii', $pageId, \CE\Client::getId());
			$stmt->execute();

			$stmt->bind_result($elemId);
			if ($stmt->fetch()){
			   return true;
			}else{
				return false;
			}

		}catch(mysqli_sql_exception $e){
			\CE\Error::report($e->getMessage());
		}
	}


}
?>